; elevator events
; by chris read

	processor f8

clrscrn         =       $00d0                                   
delay           =       $008f
pushk           =       $0107                                   
popk            =       $011e
drawchar        =       $0679

red     =   $40
blue    =   $80
green   =   $00
bkg     =   $C0
clear	=	$FF

; variable list:
; not needed, but it really helps to keep track of our variables!
; lisu 2
;   lisl 0 - legs x
;   lisl 1 - legs y
;   lisl 2 - body x
;   lisl 3 - body y
;   lisl 4 - head x
;   lisl 5 - head y
;	lisl 6 - moving timer
;	lisl 7 - controls

; lisu 3
;	lisl 0 - elevator3 x
;	lisl 1 - elevator3 y
;   lisl 2 - elevator2 x
;   lisl 3 - elevator2 y
;   lisl 4 - elevator1 x
;   lisl 5 - elevator1 y
;  	lisl 6 - eleaator3 dir
; 	lisl 7 - elevator2 dir

; lisu 4
;	lisl 0 - elevator1 dir	

; the beginning of our program
	org	$800

cartridgeStart:
	.byte	$55, $2B					
	
	li	$c6			
	lr	3, A						
	pi	clrscrn						

	dci	gfx.elevators.bmp.parameters
	pi	MultiBlitGraphic

title:
	pi	readController
	ni	%10000000				; is fire pressed?
	bnz	loop_setup				
	
	jmp title
	
move_title:
	jmp title
	
loop_setup:
	pi	readController
	ni	%10000000				; is fire pressed?
	bz	loop_setup			
	
	lisu	2
	lisl	0

	li	70		; set x to 79
	lr	I, A		
	li  49		; set y to 48
	lr  I, A
	li	70		; set x to 79
	lr	I, A		
	li  49		; set y to 48
	lr  I, A	
	li	70		; set x to 79
	lr	I, A		
	li  49		; set y to 48
	lr  I, A	
	li	1		; set timer to 1
	lr	I, A		
	
	lisu	3
	lisl	0

	li	61
	lr	I, A		
	li  40	
	lr  I, A
	li	47		
	lr	I, A		
	li  30	
	lr  I, A	
	li	33		
	lr	I, A		
	li  20		
	lr  I, A	
	li	1		
	lr	I, A			
	li  2		
	lr  I, A	

	lisu	4
	lisl	0

	li  2	
	lr	I, A		

	;pi draw_body_and_head
	pi draw_sprite_1
	
loop:
	pi move_elevators	
	pi draw_elevators	

	pi Controls	; call the controller function
	pi move_sprite_x

	pi fucker

	pi Collision_Check

	lisu	2	
	lisl	6
	lr A, S
	ci	255
	bz pre_title	

	jmp loop

pre_title:
	; load x coordinate
	lisu	2
	lisl	0

	pi  erase_sprite
	
	; load x coordinate
	lisu	3
	lisl	0

	pi  erase_sprite	
	
	; load x coordinate
	lisu	3
	lisl	2

	pi  erase_sprite	
	
	; load x coordinate
	lisu	3
	lisl	4

	pi  erase_sprite	
	
	jmp title


moveUp:	
	; load x coordinate
	lisu	2
	lisl	0

	pi  erase_sprite

	; subtract x by 1
	lisu	2	
	lisl	1
	lr A, S
	ai	248
	lr S, A	
	
	pi	popk
	pk							; return from the subroutine	
	

move_sprite_x:
	; save the return address
	lr	K, P
	pi	pushk

	lisu   2
	lisl   7

	; test for left
	lis	%0010
	ns	S
	bnz	moveLeft
	; test for right
	lis	1
	ns	S
	bnz	moveRight__			
	; none
	pi	popk
	pk							; return from the subroutine		
	
moveRight__:
	jmp moveRight
		
moveLeft:
	lisu	2	
	lisl	0
	lr A, S
	ci	23				
	bp	do_i_move_up_left

	lisl	6
	lr	A, S
	inc								
	lr	S, A

	;pi erase_sprite

	; subtract x by 1
	lisl	0
	ds	S	
	lr A, S	


	pi move_elevators	
	pi draw_elevators	
	
	;pi draw_body_and_head
	
	pi Collision_Check
	

	lisu	2	
	lisl	6
	lr A, S
	ci	8		
	bp	draw_sprite_11_
	
	pi draw_sprite_2

	pi	popk
	pk							; return from the subroutine	
	
draw_sprite_11_:
		jmp draw_sprite_11
	
do_i_move_up_left:	
	lisu	2	
	lisl	1
	lr A, S
	ci	49				
	bz	moveUp
	
	ci	33				
	bz	moveUp	
	
	ci	17				
	bz	moveUp		

	pi	popk
	pk							; return from the subroutine

do_i_move_up_right:	
	lisu	2	
	lisl	1
	lr A, S
	ci	41				
	bz	moveUp
	
	ci	25				
	bz	moveUp	
	
	;ci	9				
	;bz	moveUp		

	pi	popk
	pk							; return from the subroutine	

fucker:
	; save the return address
	lr	K, P
	pi	pushk

	lisu	2	
	lisl	6
	lr A, S
	ci	8		
	bp	draw_sprite_1b
	
	pi draw_sprite_2b

	pi	popk
	pk							; return from the subroutine	


draw_sprite_1b:

	jmp draw_sprite_1c

stopsprite_:
	jmp do_i_move_up_right

moveRight:
	lisu	2	
	lisl	0
	lr A, S
	ci	70				
	bm	stopsprite_
	
	lisl	6
	lr	A, S
	inc								
	lr	S, A
	
	; add x by 1
	lisl	0
	lr	A, S
	inc								
	lr	S, A

	;pi draw_body_and_head
	pi move_elevators	
	pi draw_elevators	
	
	pi Collision_Check	
	
	lisu	2	
	lisl	6
	lr A, S
	ci	8			
	bp	draw_sprite_11
	
	pi draw_sprite_2

	pi	popk
	pk							; return from the subroutine	

draw_sprite_11:
	pi draw_sprite_1
	
	pi	popk
	pk							; return from the subroutine

drawSprites:
	; save the return address
	lr	K, P
	pi	pushk

	lr	A, I
	lr	2, A
	; load y coordinate
	lr	A, S
	lr	3, A
	; draw the sprite

	; blit reference:
	; r1 = color 1 (off)
	; r2 = color 2 (on)
	; r3 = x position
	; r4 = y position
	; r5 = width
	; r6 = height

	; get the tile address
	dci	sprites
	; add the offset
	lr	A, 4
	inc							; make sure we hit 0
	lr	0, A
	lis	2						; two bytes for each sprite
sprite.draw.addressLoop:
	ds	0
	bz	sprite.draw.addressLoop.end
	adc
	br	sprite.draw.addressLoop
sprite.draw.addressLoop.end:
	; load the address for this sprite's number
	lm
	lr	Qu, A
	lm
	lr	Ql, A
	lr	DC, Q
	
	; load the sprite size (8x7)
	lis	8
	lr	5, A
	lis	7
	lr	6, A
	; load the position
	lr	A, 3
	lr	4, A
	lr	A, 2
	lr	3, A
	
	pi	popk
	pk							; return from the subroutine	

readController:
	; see one of the hand controllers is moved
	clr
	outs	0
	outs	4
	ins	4
	com							; un-invert port data
	ni	$cf						; mask off twists, since we don't use them
	bnz	readControllerEnd
	outs	1
	ins	1
	com
	ni	$cf
readControllerEnd:
	pop

Controls:
	; start a subroutine
	
	; save return address
	lr	K, P
	pi	pushk

	; get controller input
	pi	readController
	; and save it
	lr	4, A
	lr  A, 4

	; set ISAR for direction
	lisu	2
	lisl	7
	; load the direction in
	lr	S, A

	pi	popk
	pk							; return from the subroutine


erase_sprite:
	; save return address
	lr	K, P
	pi	pushk

	li 6		
	lr 4, A						; store index in r4

	; draw the sprite
	pi	drawSprites
	
	; load the colors
	li	bkg
	lr	2, A
	li	clear
	lr	1, A

	; draw the sprite
	pi	blit	
	
	pi	popk
	pk							; return from the subroutine	

draw_sprite_1:	
	; save return address
	lr	K, P
	pi	pushk



	; load x coordinate
	lisu	2
	lisl	0

	pi erase_sprite

	
draw_sprite_1c:
	li 0		
	lr 4, A						; store index in r4

	; load x coordinate
	lisu	2
	lisl	0

	; draw the sprite
	pi	drawSprites
	
	; load the colors
	li	blue
	lr	2, A


	; draw the sprite
	pi	blit

	li 2		
	lr 4, A						; store index in r4


	; load x coordinate
	lisu	2
	lisl	0

	; draw the sprite
	pi	drawSprites
	
	; load the colors
	li	green
	lr	2, A


	; draw the sprite
	pi	blit
	
	li 3		
	lr 4, A						; store index in r4

	; load x coordinate
	lisu	2
	lisl	0

	; draw the sprite
	pi	drawSprites
	
	; load the colors
	li	red
	lr	2, A


	; draw the sprite
	pi	blit	
	
	
	pi	popk
	pk							; return from the subroutine	
	
draw_sprite_2:	
	; save return address
	lr	K, P
	pi	pushk
	
	
	; load x coordinate
	lisu	2
	lisl	0

	pi erase_sprite	
	
draw_sprite_2b:
	lisu	2	
	lisl	6
	lr A, S
	ci	15
	bz reset_timer	

	li 7		
	lr 4, A						; store index in r4

	; load x coordinate
	lisu	2
	lisl	0

	; draw the sprite
	pi	drawSprites
	
	; load the colors
	li	red
	lr	2, A
	li	clear
	lr	1, A

	; draw the sprite
	pi	blit

	; load x coordinate
	lisu	2
	lisl	0	

	
	li 1		
	lr 4, A						; store index in r4

	; draw the sprite
	pi	drawSprites
	
	; load the colors
	li	blue
	lr	2, A


	; draw the sprite
	pi	blit
	

	li 2		
	lr 4, A						; store index in r4

	; load x coordinate
	lisu	2
	lisl	0

	; draw the sprite
	pi	drawSprites
	
	; load the colors
	li	green
	lr	2, A


	; draw the sprite
	pi	blit

	
	pi	popk
	pk							; return from the subroutine		
	
	
	
	
reset_timer:
	lisu	2
	lisl	6

	li	0		
	lr	I, A	

	pi draw_sprite_1

	pi	popk
	pk							; return from the subroutine	

draw_elevators:
	; save return address
	lr	K, P
	pi	pushk
	
	li 4		
	lr 4, A						; store index in r4

	; load x coordinate
	lisu	3
	lisl	4

	; draw the sprite
	pi	drawSprites
	
	; load the colors
	li	blue
	lr	2, A
	li	clear
	lr	1, A

	; draw the sprite
	pi	blit	
	
	li 4		
	lr 4, A						; store index in r4

	; load x coordinate
	lisu	3
	lisl	2

	; draw the sprite
	pi	drawSprites
	
	; load the colors
	li	red
	lr	2, A
	li	clear
	lr	1, A

	; draw the sprite
	pi	blit	
	
	li 4		
	lr 4, A						; store index in r4

	; load x coordinate
	lisu	3
	lisl	0

	; draw the sprite
	pi	drawSprites
	
	; load the colors
	li	green
	lr	2, A
	li	clear
	lr	1, A

	; draw the sprite
	pi	blit	
	
	pi	popk
	pk							; return from the subroutine
	
	
; lisu 3
;	lisl 0 - elevator3 x
;	lisl 1 - elevator3 y
;   lisl 2 - elevator2 x
;   lisl 3 - elevator2 y
;   lisl 4 - elevator1 x
;   lisl 5 - elevator1 y
;  	lisl 6 - eleaator3 dir
; 	lisl 7 - elevator2 dir

; lisu 4
;	lisl 0 - elevator1 dir	
	
move_elevators:
	; save return address
	lr	K, P
	pi	pushk

	; elevator 1

	li 5		
	lr 4, A						; store index in r4

	; load x coordinate
	lisu	3
	lisl	4

	; draw the sprite
	pi	drawSprites
	
	; load the colors
	li	blue
	lr	2, A
	li	bkg
	lr	1, A

	; draw the sprite
	pi	blit	
	
	lisu	4	
	lisl	0
	lr A, S
	ci	1			
	bz	elevator1_down
	

elevator1_up:
	lisu	3
	lisl	5
	ds	S	
	lr A, S	

	lisu	3	
	lisl	5
	lr A, S
	ci	10			
	bz	change_elevator_1_to_down
	
	jmp elevator_2


elevator1_down:
	lisu	3
	lisl	5
	lr	A, S
	inc								
	lr	S, A
	
	lisu	3	
	lisl	5
	lr A, S
	ci	48		
	bz	change_elevator_1_to_up
	
	jmp elevator_2

change_elevator_1_to_down:
	lisu	4
	lisl	0

	li	1		; set x to 79
	lr	I, A	

	jmp elevator_2

change_elevator_1_to_up:
	lisu	4
	lisl	0

	li	2		; set x to 79
	lr	I, A	

	jmp elevator_2
	
	; elevator 2

elevator_2:

	li 5
	lr 4, A						; store index in r4

	; load x coordinate
	lisu	3
	lisl	2

	; draw the sprite
	pi	drawSprites
	
	; load the colors
	li	red
	lr	2, A
	li	bkg
	lr	1, A

	; draw the sprite
	pi	blit	
	
	
	lisu	3	
	lisl	7
	lr A, S
	ci	1			
	bz	elevator2_down
	

elevator2_up:
	lisu	3
	lisl	3
	ds	S	
	lr A, S	

	lisu	3	
	lisl	3
	lr A, S
	ci	10		
	bz	change_elevator_2_to_down
	
	jmp elevator_3


elevator2_down:
	lisu	3
	lisl	3
	lr	A, S
	inc								
	lr	S, A
	
	lisu	3	
	lisl	3
	lr A, S
	ci	48		
	bz	change_elevator_2_to_up
	
	jmp elevator_3

change_elevator_2_to_down:
	lisu	3
	lisl	7

	li	1		; set x to 79
	lr	I, A	

	jmp elevator_3

change_elevator_2_to_up:
	lisu	3
	lisl	7

	li	2		; set x to 79
	lr	I, A	

	jmp elevator_3
	
elevator_3:
	li 5		
	lr 4, A						; store index in r4

	; load x coordinate
	lisu	3
	lisl	0

	; draw the sprite
	pi	drawSprites
	
	; load the colors
	li	green
	lr	2, A
	li	bkg
	lr	1, A

	; draw the sprite
	pi	blit	
	
	lisu	3	
	lisl	6
	lr A, S
	ci	1			
	bz	elevator3_down
	

elevator3_up:
	lisu	3
	lisl	1
	ds	S	
	lr A, S	


	lisu	3	
	lisl	1
	lr A, S
	ci	10		
	bz	change_elevator_3_to_down
	
	jmp elevator_4


elevator3_down:
	lisu	3
	lisl	1
	lr	A, S
	inc								
	lr	S, A
	
	lisu	3	
	lisl	1
	lr A, S
	ci	48			
	bz	change_elevator_3_to_up
	
	jmp elevator_4

change_elevator_3_to_down:
	lisu	3
	lisl	6

	li	1		; set x to 79
	lr	I, A	

	jmp elevator_4

change_elevator_3_to_up:
	lisu	3
	lisl	6

	li	2		; set x to 79
	lr	I, A	

elevator_4:
	pi	popk
	pk							; return from the subroutine	
	
Collision_Check:
	; save the return address
	lr	K, P
	pi	pushk

	LISU 2 
    LISL 1 

    LR A, S ;load the value from that register into A
    COM ;complement A (this means A = 255 - A)

	LISU 3
    LISL 1  ;point to register 4 of bank 6
    
    AS S    ;add that register to A, so now A contains the value of (Register 2 - Register 6 of bank 3 - 1)

    CI 4    ;Set carry flag if A > 2
    BC X_Collision_elev1 ;branch to subLives if carry was clear (Reg. 2 - Reg. 6 <= 3)

    CI 249  ;else compare against 250 (set carry flag if A > 250)
    BNC X_Collision_elev1 ;branch to subLives if carry was set (Reg. 2 - Reg. 6 > -5)	
	
	jmp coll_elev2
	
X_Collision_elev1:
    LISU 2 ;point the ISAR at bank 6
    LISL 0 ;register 2 of bank 6

    LR A, S ;load the value from that register into A
    COM ;complement A (this means A = 255 - A)

	LISU 3
    LISL 0  ;point to register 4 of bank 6
    
    AS S    ;add that register to A, so now A contains the value of (Register 2 - Register 6 of bank 3 - 1)

    CI 5    ;Set carry flag if A > 2
    BC collision_happened ;branch to subLives if carry was clear (Reg. 2 - Reg. 6 <= 3)

    CI 248  ;else compare against 250 (set carry flag if A > 250)
    BNC collision_happened ;branch to subLives if carry was set (Reg. 2 - Reg. 6 > -5)	

	
coll_elev2:
	LISU 2 ;point the ISAR at bank 6
    LISL 1 ;register 2 of bank 6

    LR A, S ;load the value from that register into A
    COM ;complement A (this means A = 255 - A)

	LISU 3
    LISL 3  ;point to register 4 of bank 6
    
    AS S    ;add that register to A, so now A contains the value of (Register 2 - Register 6 of bank 3 - 1)

    CI 4    ;Set carry flag if A > 2
    BC X_Collision_elev2 ;branch to subLives if carry was clear (Reg. 2 - Reg. 6 <= 3)

    CI 249  ;else compare against 250 (set carry flag if A > 250)
    BNC X_Collision_elev2 ;branch to subLives if carry was set (Reg. 2 - Reg. 6 > -5)	
	
	jmp coll_elev3
	
X_Collision_elev2:
    LISU 2 ;point the ISAR at bank 6
    LISL 0 ;register 2 of bank 6

    LR A, S ;load the value from that register into A
    COM ;complement A (this means A = 255 - A)

	LISU 3
    LISL 2  ;point to register 4 of bank 6
    
    AS S    ;add that register to A, so now A contains the value of (Register 2 - Register 6 of bank 3 - 1)

    CI 5    ;Set carry flag if A > 2
    BC collision_happened ;branch to subLives if carry was clear (Reg. 2 - Reg. 6 <= 3)

    CI 248  ;else compare against 250 (set carry flag if A > 250)
    BNC collision_happened ;branch to subLives if carry was set (Reg. 2 - Reg. 6 > -5)	
	
coll_elev3:
	LISU 2 ;point the ISAR at bank 6
    LISL 1 ;register 2 of bank 6

    LR A, S ;load the value from that register into A
    COM ;complement A (this means A = 255 - A)

	LISU 3
    LISL 5  ;point to register 4 of bank 6
    
    AS S    ;add that register to A, so now A contains the value of (Register 2 - Register 6 of bank 3 - 1)

    CI 4    ;Set carry flag if A > 2
    BC X_Collision_elev3 ;branch to subLives if carry was clear (Reg. 2 - Reg. 6 <= 3)

    CI 249  ;else compare against 250 (set carry flag if A > 250)
    BNC X_Collision_elev3 ;branch to subLives if carry was set (Reg. 2 - Reg. 6 > -5)	
	
	jmp End_collision
	
X_Collision_elev3:
    LISU 2 ;point the ISAR at bank 6
    LISL 0 ;register 2 of bank 6

    LR A, S ;load the value from that register into A
    COM ;complement A (this means A = 255 - A)

	LISU 3
    LISL 4  ;point to register 4 of bank 6
    
    AS S    ;add that register to A, so now A contains the value of (Register 2 - Register 6 of bank 3 - 1)

    CI 5    ;Set carry flag if A > 2
    BC collision_happened ;branch to subLives if carry was clear (Reg. 2 - Reg. 6 <= 3)

    CI 248 ;else compare against 250 (set carry flag if A > 250)
    BNC collision_happened ;branch to subLives if carry was set (Reg. 2 - Reg. 6 > -5)	


End_collision:
	pi	popk
	pk							; return from the subroutine	

collision_happened:
	lisu	2
	lisl	6

	li	255
	lr	I, A	

	pi	popk
	pk							; return from the subroutine	

; our files to include
	include "elevators.inc"
	include "elevgraphics.inc"
	include "elevdrawing.inc"

; the end of the program.
; needed to make the program size an even number of kb. Must be a maximum of 15 bytes.
	org $27f0

signature:
	.byte	".chris read 2019"